﻿-- Title: AudioProc by badgerbadger@kilrogg.us
-- Inspired by previous works of: buahh@baelgun.eu, yheen@baelgun.eu, nekrotik@shandris.us
-- Thanks: zehn@kilrogg.us, rumpl@kilrogg.us, pearle@kilrogg.us, ackis, xinhuan

local AudioProcVersion = "1.6"
local playerName = UnitName("player")
local data = {

-- class
		[59052] = "Interface\\AddOns\\AudioProc\\sounds\\freezingfog.mp3", -- DK_FF
		[51124] = "Interface\\AddOns\\AudioProc\\sounds\\killingmachine.mp3", -- DK_KM
		[16870] = "Interface\\AddOns\\AudioProc\\sounds\\clearcast.mp3", -- Druid_CC
		[48518] = "Interface\\AddOns\\AudioProc\\sounds\\lunareclipse.mp3", -- Druid_LE
		[16886] = "Interface\\AddOns\\AudioProc\\sounds\\naturesgrace.mp3", -- Druid_NG
		[48517] = "Interface\\AddOns\\AudioProc\\sounds\\solareclipse.mp3", -- Druid_SE
		[56453] = "Interface\\AddOns\\AudioProc\\sounds\\lockandload.mp3", -- Hunter_LL
		[57761] = "Interface\\AddOns\\AudioProc\\sounds\\brainfreeze.mp3", -- Mage_BF
		[44544] = "Interface\\AddOns\\AudioProc\\sounds\\fingeroffrost.mp3", -- Mage_FOF
		[48108] = "Interface\\AddOns\\AudioProc\\sounds\\hotstreak.mp3", -- Mage_HS
		[64343] = "Interface\\AddOns\\AudioProc\\sounds\\impact.mp3", -- Mage_Impact
		[44401] = "Interface\\AddOns\\AudioProc\\sounds\\missilebarrage.mp3", -- Mage_MB
		[66233] = "Interface\\AddOns\\AudioProc\\sounds\\ardentdefender.mp3", -- Paladin_AD
		[59578] = "Interface\\AddOns\\AudioProc\\sounds\\artofwar.mp3", -- Paladin_AOW
		[31930] = "Interface\\AddOns\\AudioProc\\sounds\\gulp.mp3", -- Paladin_JOW
		[47535] = "Interface\\AddOns\\AudioProc\\sounds\\gulp.mp3", -- Priest_RAP1
		[47536] = "Interface\\AddOns\\AudioProc\\sounds\\gulp.mp3", -- Priest_RAP2
		[47537] = "Interface\\AddOns\\AudioProc\\sounds\\gulp.mp3", -- Priest_RAP3
		[33151] = "Interface\\AddOns\\AudioProc\\sounds\\surge.mp3", -- Priest_SOL
		[31230] = "Interface\\AddOns\\AudioProc\\sounds\\cheatdeath.mp3", -- Rogue_CD
		[53817] = "Interface\\AddOns\\AudioProc\\sounds\\maelstromweapon.mp3", -- Shaman_MW
		[34936] = "Interface\\AddOns\\AudioProc\\sounds\\backlash.mp3", -- Warlock_BL
		[63165] = "Interface\\AddOns\\AudioProc\\sounds\\decimate.mp3", -- Warlock_D1
		[63167] = "Interface\\AddOns\\AudioProc\\sounds\\decimate.mp3", -- Warlock_D2
		[54278] = "Interface\\AddOns\\AudioProc\\sounds\\empowered.mp3", -- Warlock_EI
		[47283] = "Interface\\AddOns\\AudioProc\\sounds\\empowered.mp3", -- Warlock_EI
		[17941] = "Interface\\AddOns\\AudioProc\\sounds\\shadowtrance.mp3", -- Warlock_ST
		[46916] = "Interface\\AddOns\\AudioProc\\sounds\\bloodsurge.mp3", -- Warrior_BS
		[50227] = "Interface\\AddOns\\AudioProc\\sounds\\swordandboard.mp3", -- Warrior_SAB
		[52437] = "Interface\\AddOns\\AudioProc\\sounds\\suddendeath.mp3", -- Warrior_SD
-- Enchant
		[59620] = "Interface\\AddOns\\AudioProc\\sounds\\proc.mp3", -- Berserking
		[59626] = "Interface\\AddOns\\AudioProc\\sounds\\proc.mp3", -- BlackMagic
		[64440] = "Interface\\AddOns\\AudioProc\\sounds\\proc.mp3", -- BladeWard
		[64568] = "Interface\\AddOns\\AudioProc\\sounds\\proc.mp3", -- BloodDraining
		[28093] = "Interface\\AddOns\\AudioProc\\sounds\\proc.mp3", -- Mongoose
		[55637] = "Interface\\AddOns\\AudioProc\\sounds\\proc.mp3", -- Lightweave
		[55775] = "Interface\\AddOns\\AudioProc\\sounds\\proc.mp3", -- Shadowguard
-- Gem
		[55341] = "Interface\\AddOns\\AudioProc\\sounds\\gulp.mp3", -- IED1
		[55382] = "Interface\\AddOns\\AudioProc\\sounds\\gulp.mp3", -- IED2
-- Tier
		[67117] = "Interface\\AddOns\\AudioProc\\sounds\\bonus.mp3", -- DK_T9D2
		[70654] = "Interface\\AddOns\\AudioProc\\sounds\\bonus.mp3", -- DK_T10B4
		[70657] = "Interface\\AddOns\\AudioProc\\sounds\\bonus.mp3", -- DK_T10D4
		[90459] = "Interface\\AddOns\\AudioProc\\sounds\\bonus.mp3", -- DK_T11D4
		[90163] = "Interface\\AddOns\\AudioProc\\sounds\\bonus.mp3", -- Druid_T11B4
		[90165] = "Interface\\AddOns\\AudioProc\\sounds\\bonus.mp3", -- Druid_T11F4
		[90158] = "Interface\\AddOns\\AudioProc\\sounds\\bonus.mp3", -- Druid_T11R4
		[67151] = "Interface\\AddOns\\AudioProc\\sounds\\bonus.mp3", -- Hunter_T94
		[70728] = "Interface\\AddOns\\AudioProc\\sounds\\bonus.mp3", -- Hunter_T102
		[71007] = "Interface\\AddOns\\AudioProc\\sounds\\bonus.mp3", -- Hunter_T104
		[67188] = "Interface\\AddOns\\AudioProc\\sounds\\bonus.mp3", -- Paladin_T9R2
		[67189] = "Interface\\AddOns\\AudioProc\\sounds\\bonus.mp3", -- Paladin_T9R4
		[70757] = "Interface\\AddOns\\AudioProc\\sounds\\bonus.mp3", -- Paladin_T10H4
		[70760] = "Interface\\AddOns\\AudioProc\\sounds\\bonus.mp3", -- Paladin_T10P4
		[70765] = "Interface\\AddOns\\AudioProc\\sounds\\bonus.mp3", -- Paladin_T10R2
		[90313] = "Interface\\AddOns\\AudioProc\\sounds\\bonus.mp3", -- Paladin_T11H4
		[89911] = "Interface\\AddOns\\AudioProc\\sounds\\bonus.mp3", -- Priest_T11H4
		[67210] = "Interface\\AddOns\\AudioProc\\sounds\\bonus.mp3", -- Rogue_T9
		[70802] = "Interface\\AddOns\\AudioProc\\sounds\\bonus.mp3", -- Rogue_T10
		[90473] = "Interface\\AddOns\\AudioProc\\sounds\\bonus.mp3", -- Rogue_T114
		[70829] = "Interface\\AddOns\\AudioProc\\sounds\\bonus.mp3", -- Shaman_T10EN2
		[70831] = "Interface\\AddOns\\AudioProc\\sounds\\bonus.mp3", -- Shaman_T10EN4
		[70806] = "Interface\\AddOns\\AudioProc\\sounds\\bonus.mp3", -- Shaman_T10R2
		[90499] = "Interface\\AddOns\\AudioProc\\sounds\\bonus.mp3", -- Shaman_T11R4
		[70840] = "Interface\\AddOns\\AudioProc\\sounds\\bonus.mp3", -- Warlock_T10
		[89935] = "Interface\\AddOns\\AudioProc\\sounds\\bonus.mp3", -- Warlock_T114
		[70855] = "Interface\\AddOns\\AudioProc\\sounds\\bonus.mp3", -- Warrior_T10D2
		[70847] = "Interface\\AddOns\\AudioProc\\sounds\\bonus.mp3", -- Warrior_T10D4
		[90295] = "Interface\\AddOns\\AudioProc\\sounds\\bonus.mp3", -- Warrior_T11D4
--Rings
		[60318] = "Interface\\AddOns\\AudioProc\\sounds\\bonus.mp3", -- EI
		[72418] = "Interface\\AddOns\\AudioProc\\sounds\\bonus.mp3", -- CK
		[72416] = "Interface\\AddOns\\AudioProc\\sounds\\bonus.mp3", -- FS
		[72412] = "Interface\\AddOns\\AudioProc\\sounds\\bonus.mp3", -- FC
		[72414] = "Interface\\AddOns\\AudioProc\\sounds\\bonus.mp3", -- FD
-- Trinket
		[60234] = "Interface\\AddOns\\AudioProc\\sounds\\proc.mp3", -- Greatness
		[60235] = "Interface\\AddOns\\AudioProc\\sounds\\proc.mp3", -- Greatness2
		[60229] = "Interface\\AddOns\\AudioProc\\sounds\\proc.mp3", -- Greatness3
		[60233] = "Interface\\AddOns\\AudioProc\\sounds\\proc.mp3", -- Greatness4
-- Weapon
		[71864] = "Interface\\AddOns\\AudioProc\\sounds\\trauma.mp3", -- FOL1
		[71866] = "Interface\\AddOns\\AudioProc\\sounds\\trauma.mp3", -- FOL2
}

-- Spam a loading message
DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF80Audio|cff99ff33Proc|cffffffff loaded! Type /audioproc for help.")

-- A frame to receive events
local AudioProcFrame = CreateFrame("Frame")

-- The slash command
SLASH_APALARM1 = "/audioproc"
SlashCmdList["APALARM"] = function (msg)
    if msg == "on" then
        AudioProc.Sound = true;
        DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF80Audio|cff99ff33Proc|cffffffff Sound: |cff33ff99ON")
        PlaySoundFile("Interface\\AddOns\\AudioProc\\sounds\\empowered.mp3")
        AudioProcFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
    elseif msg == "off" then
        AudioProc.Sound = false
        DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF80Audio|cff99ff33Proc|cffffffff Sound: |cFFFF8080OFF")
        PlaySoundFile("Interface\\AddOns\\AudioProc\\sounds\\audioproc_off.mp3")
        AudioProcFrame:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
    else
        local sound_status
        if AudioProc.Sound then 
            sound_status = "|cFF80FF80noisy"
        else
            sound_status = "|cFFFF8080silent"
        end
        DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF80Audio|cff99ff33Proc|cffffffff v"..AudioProcVersion.." is "..sound_status..".")
        DEFAULT_CHAT_FRAME:AddMessage("Type /audioproc on/off")
    end
end

-- The event function
 print(event, ...)
AudioProcFrame:SetScript("OnEvent", function(self, event, ...)
    local arg1 = ...

    if event == "COMBAT_LOG_EVENT_UNFILTERED" then
        local timestamp, eventType, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, arg1 = ...
        if eventType == "SPELL_AURA_APPLIED" and dstName == playerName and arg1 and data[arg1] then
            PlaySoundFile(data[arg1])
        end

    elseif event == "ADDON_LOADED" and arg1 == "AudioProc" then
        -- Set defaults if non-existant
        if not AudioProc then
            AudioProc = {
                Sound = true
            }
        end
        if AudioProc.Sound then
            AudioProcFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
        end
    end
end)

AudioProcFrame:RegisterEvent("ADDON_LOADED")